> For the complete documentation index, see [llms.txt](https://docs.frends.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.frends.com/reference/frends-platform-api/platform-api-reference/process-deployments.md).

# Process Deployments

## List Process deployments

> If response data is empty there were no deployed Processes found with the chosen filters

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ProcessDeployments"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/process-deployments":{"get":{"tags":["ProcessDeployments"],"summary":"List Process deployments","description":"If response data is empty there were no deployed Processes found with the chosen filters","operationId":"GetDeployments","parameters":[{"name":"PageNumber","in":"query","description":"Current page number. Default value is 1.","schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"}},{"name":"PageSize","in":"query","description":"Maximum page size is 200. Default page size is 30.","schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"}},{"name":"agentGroupId","in":"query","description":"Filter Process deployments by Agent group","schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"}},{"name":"processName","in":"query","description":"Filter Process deployments by Process name","schema":{"type":"string"}},{"name":"processGuid","in":"query","description":"Filter Process deployments by Process Unique Identifier","schema":{"type":"string","format":"uuid"}},{"name":"tags","in":"query","description":"Filter Process deployments by tags","schema":{"type":"array","items":{"type":"string"}}},{"name":"excludeSubprocesses","in":"query","description":"Filter Process deployments to exclude subprocesses","schema":{"type":"boolean"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PagedResponseOfDtoProcessDeploymentGet"}}}},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"PagedResponseOfDtoProcessDeploymentGet":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/DtoProcessDeploymentGet"},"description":"Response data"},"paging":{"description":"Response paging","$ref":"#/components/schemas/PagingModel"}}},"DtoProcessDeploymentGet":{"required":["agentGroup","deploymentId","processId","processName","processGuid","processVersion","processBuildVersion","triggersActive"],"type":"object","properties":{"agentGroup":{"$ref":"#/components/schemas/DtoAgentGroupBase"},"deploymentId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the deployment.","format":"int64"},"processId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for Process version.","format":"int64"},"processName":{"type":["null","string"],"description":"Process name"},"processGuid":{"type":"string","description":"Process unique identifier. This is shared between all versions of the Process.","format":"uuid"},"processVersion":{"type":["null","string"],"description":"Process version in the format X.Y.Z."},"processBuildVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Process build version. This version is incremented by 1 on every successful Process build.","format":"int32"},"deployedAtUtc":{"type":["null","string"],"format":"date-time"},"deployedBy":{"type":["null","string"]},"description":{"type":["null","string"],"description":"Optional description for deployment"},"triggersActive":{"type":"boolean","description":"Are Process Triggers active"}}},"DtoAgentGroupBase":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the Agent Group","format":"int64"},"displayName":{"type":["null","string"],"description":"Display name for the Agent Group"}}},"PagingModel":{"type":"object","properties":{"currentPage":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Current page","format":"int32"},"pageSize":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Number of entries per page","format":"int32"},"totalCount":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Total number of entries","format":"int32"},"firstPage":{"type":["null","string"],"description":"Url of the first page","format":"uri"},"lastPage":{"type":["null","string"],"description":"Url of the last page","format":"uri"},"nextPage":{"type":["null","string"],"description":"Url of the next page","format":"uri"},"previousPage":{"type":["null","string"],"description":"Url of the previous page","format":"uri"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## Deploy Processes to an Agent group

> Deploy up to 20 Processes to an Agent group. The following validation rules apply to deploying a Process: All used Environment variables need to have values set. All used Subprocesses need to be deployed to the target Agent group/Environment Process Target Framework needs to match Agent group framework. You can also deploy an older version of a Process to the 'Default' Agent group.

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ProcessDeployments"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/process-deployments":{"post":{"tags":["ProcessDeployments"],"summary":"Deploy Processes to an Agent group","description":"Deploy up to 20 Processes to an Agent group. The following validation rules apply to deploying a Process: All used Environment variables need to have values set. All used Subprocesses need to be deployed to the target Agent group/Environment Process Target Framework needs to match Agent group framework. You can also deploy an older version of a Process to the 'Default' Agent group.","requestBody":{"description":"Model for deploying Processes","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DtoProcessDeploymentCreate"}}},"required":true},"responses":{"201":{"description":"Created","headers":{"Location":{"description":"Details the deployed Process. If multiple Processes are deployed in one batch the Location header will link to get all deployments","schema":{"type":"string"}}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfListOfDtoProcessDeploymentGet"}}}},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"DtoProcessDeploymentCreate":{"required":["agentGroupId","processes","activateTriggers","deploymentDescription"],"type":"object","properties":{"agentGroupId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"processes":{"maxItems":20,"type":"array","items":{"$ref":"#/components/schemas/ProcessVersionInputModel"}},"activateTriggers":{"type":"boolean","description":"Whether to automatically activate Triggers for Processes on deployment. Default is true."},"deploymentDescription":{"type":"string"}}},"ProcessVersionInputModel":{"type":"object","properties":{"processGuid":{"type":"string","format":"uuid"},"version":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"processVariables":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ProcessVariable"}}}},"ProcessVariable":{"type":"object","properties":{"name":{"type":["null","string"]},"value":{"type":["null","string"]},"isSecret":{"type":"boolean"},"mode":{"type":["null","string"]},"description":{"type":["null","string"]}}},"ResponseOfListOfDtoProcessDeploymentGet":{"required":["data"],"type":"object","properties":{"data":{"type":["null","array"],"items":{"$ref":"#/components/schemas/DtoProcessDeploymentGet"},"description":"Response data"}}},"DtoProcessDeploymentGet":{"required":["agentGroup","deploymentId","processId","processName","processGuid","processVersion","processBuildVersion","triggersActive"],"type":"object","properties":{"agentGroup":{"$ref":"#/components/schemas/DtoAgentGroupBase"},"deploymentId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the deployment.","format":"int64"},"processId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for Process version.","format":"int64"},"processName":{"type":["null","string"],"description":"Process name"},"processGuid":{"type":"string","description":"Process unique identifier. This is shared between all versions of the Process.","format":"uuid"},"processVersion":{"type":["null","string"],"description":"Process version in the format X.Y.Z."},"processBuildVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Process build version. This version is incremented by 1 on every successful Process build.","format":"int32"},"deployedAtUtc":{"type":["null","string"],"format":"date-time"},"deployedBy":{"type":["null","string"]},"description":{"type":["null","string"],"description":"Optional description for deployment"},"triggersActive":{"type":"boolean","description":"Are Process Triggers active"}}},"DtoAgentGroupBase":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the Agent Group","format":"int64"},"displayName":{"type":["null","string"],"description":"Display name for the Agent Group"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## Get single Process deployment

> Gets detailed information for a single Process deployment. Currently this is the same response model as 'List Process deployments'

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ProcessDeployments"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/process-deployments/{id}":{"get":{"tags":["ProcessDeployments"],"summary":"Get single Process deployment","description":"Gets detailed information for a single Process deployment. Currently this is the same response model as 'List Process deployments'","operationId":"SingleDeployment","parameters":[{"name":"id","in":"path","description":"Deployment identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfDtoProcessDeploymentGet"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ResponseOfDtoProcessDeploymentGet":{"required":["data"],"type":"object","properties":{"data":{"oneOf":[{"type":"null"},{"description":"Response data","$ref":"#/components/schemas/DtoProcessDeploymentGet"}]}}},"DtoProcessDeploymentGet":{"required":["agentGroup","deploymentId","processId","processName","processGuid","processVersion","processBuildVersion","triggersActive"],"type":"object","properties":{"agentGroup":{"$ref":"#/components/schemas/DtoAgentGroupBase"},"deploymentId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the deployment.","format":"int64"},"processId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for Process version.","format":"int64"},"processName":{"type":["null","string"],"description":"Process name"},"processGuid":{"type":"string","description":"Process unique identifier. This is shared between all versions of the Process.","format":"uuid"},"processVersion":{"type":["null","string"],"description":"Process version in the format X.Y.Z."},"processBuildVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Process build version. This version is incremented by 1 on every successful Process build.","format":"int32"},"deployedAtUtc":{"type":["null","string"],"format":"date-time"},"deployedBy":{"type":["null","string"]},"description":{"type":["null","string"],"description":"Optional description for deployment"},"triggersActive":{"type":"boolean","description":"Are Process Triggers active"}}},"DtoAgentGroupBase":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the Agent Group","format":"int64"},"displayName":{"type":["null","string"],"description":"Display name for the Agent Group"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## Undeploy a Process from an Agent group

> It is not possible to undeploy a Process from the Development Agent group. If you wish to remove the Process completely you should use the DeleteProcess endpoint.

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ProcessDeployments"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/process-deployments/{id}":{"delete":{"tags":["ProcessDeployments"],"summary":"Undeploy a Process from an Agent group","description":"It is not possible to undeploy a Process from the Development Agent group. If you wish to remove the Process completely you should use the DeleteProcess endpoint.","parameters":[{"name":"id","in":"path","description":"Deployment identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"responses":{"204":{"description":"No Content"},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## POST /api/v1/process-deployments/{id}/execute

> Run a Process in the selected Agent group

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ProcessDeployments"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/process-deployments/{id}/execute":{"post":{"tags":["ProcessDeployments"],"summary":"Run a Process in the selected Agent group","parameters":[{"name":"id","in":"path","description":"Deployment identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"requestBody":{"description":"Used to pass parameters to Manual Trigger. Property name should be Manual Trigger parameter key.","content":{"application/json":{"schema":{"type":"object","additionalProperties":{"type":"string"}}}},"required":true},"responses":{"202":{"description":"Accepted","headers":{"Location":{"description":"Url to query for Process execution result","schema":{"type":"string"}}},"content":{"text/plain":{"schema":{"type":"string"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## PUT /api/v1/process-deployments/{id}/activation

> Activate Process triggers

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ProcessDeployments"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/process-deployments/{id}/activation":{"put":{"tags":["ProcessDeployments"],"summary":"Activate Process triggers","parameters":[{"name":"id","in":"path","description":"Deployment identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"responses":{"204":{"description":"No Content"},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## DELETE /api/v1/process-deployments/{id}/activation

> Deactivate Process triggers

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ProcessDeployments"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/process-deployments/{id}/activation":{"delete":{"tags":["ProcessDeployments"],"summary":"Deactivate Process triggers","parameters":[{"name":"id","in":"path","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"responses":{"204":{"description":"No Content"},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## POST /api/v1/process-deployments/{processGuid}/agentGroup/{agentGroupId}/variableUpdate

> Update Process variables

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ProcessDeployments"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/process-deployments/{processGuid}/agentGroup/{agentGroupId}/variableUpdate":{"post":{"tags":["ProcessDeployments"],"summary":"Update Process variables","parameters":[{"name":"agentGroupId","in":"path","description":"Target agent group","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"processGuid","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"description":"New variables for the process","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ProcessVariable"}}}},"required":true},"responses":{"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProcessVariable":{"type":"object","properties":{"name":{"type":["null","string"]},"value":{"type":["null","string"]},"isSecret":{"type":"boolean"},"mode":{"type":["null","string"]},"description":{"type":["null","string"]}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## GET /api/v1/process-deployments/{agentGroupId}/variables

> List Process variables for Processes in Agent group

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ProcessDeployments"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/process-deployments/{agentGroupId}/variables":{"get":{"tags":["ProcessDeployments"],"summary":"List Process variables for Processes in Agent group","parameters":[{"name":"agentGroupId","in":"path","description":"Agent group from where to fetch Process variables from","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"processIds","in":"query","description":"List of Process ids","schema":{"type":"array","items":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"}}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfDictionaryOflongAndListOfProcessVariable"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ResponseOfDictionaryOflongAndListOfProcessVariable":{"required":["data"],"type":"object","properties":{"data":{"type":["null","object"],"additionalProperties":{"type":"array","items":{"$ref":"#/components/schemas/ProcessVariable"}},"description":"Response data"}}},"ProcessVariable":{"type":"object","properties":{"name":{"type":["null","string"]},"value":{"type":["null","string"]},"isSecret":{"type":"boolean"},"mode":{"type":["null","string"]},"description":{"type":["null","string"]}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.frends.com/reference/frends-platform-api/platform-api-reference/process-deployments.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
